local ADDON_NAME, PRIVATE_TABLE = ...

local L = LibStub("AceLocale-3.0"):GetLocale("AutoLooter")
local Util = PRIVATE_TABLE.Util
local Color = PRIVATE_TABLE.Color

local print = Util.print

local module = LibStub("AceAddon-3.0"):GetAddon("AutoLooter"):NewModule("DataBroker")

-- thanks to Pseudopath "http://wow.curseforge.com/profiles/Pseudopath/"
local AL_LDB = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject(ADDON_NAME, {
	type = "launcher",
	icon = "Interface\\Icons\\Inv_misc_bag_01",
	label = ADDON_NAME
})
local LDBIcon = LibStub("LibDBIcon-1.0")

function AL_LDB.OnTooltipShow(tip)
	tip:AddLine(Color.WHITE .. ADDON_NAME)
	tip:AddLine(" ")
	tip:AddLine(Color.YELLOW .. L["Left-click"] .. "|r " .. L["to Show/Hide UI"])
	tip:AddLine(Color.YELLOW .. L["Right-click"] .. "|r " .. L["to Enable/Disable loot all"])
end

function AL_LDB.OnClick(self, button)
	if button == "LeftButton" then
		LibStub("AceConfigDialog-3.0"):Open(ADDON_NAME)
	elseif button == "RightButton" then
		PRIVATE_TABLE.DB.lootAll = not PRIVATE_TABLE.DB.lootAll
		print(L["Loot everything"], ": ", Util.OnOff(PRIVATE_TABLE.DB.lootAll))
	end
end

function module.SetMinimapVisibility(show)
	PRIVATE_TABLE.DB.minimap.hide = not show

	if (show) then
		LDBIcon:Show(ADDON_NAME)
	else
		LDBIcon:Hide(ADDON_NAME)
	end
end

function module:GetOptions()
	return {
		general = {
			args = {
				showMinimap = {
					type = "toggle",
					name = L["Show/Hide minimap button"],
					width = "double",
					set = function(info, val) module.SetMinimapVisibility(val) end,
					get = function(info) return not PRIVATE_TABLE.DB.minimap.hide end
				}
			}
		},
	}
end

function module:OnInitialize()
	LDBIcon:Register(ADDON_NAME, AL_LDB, PRIVATE_TABLE.DB.minimap)
end
